<?php
namespace PME\Controllers\Custo;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CustoPlanejadoCardapioController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $environment, $newCode, $connection) {
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        $this->environment   = $environment;
        $this->newCode       = $newCode;
        $this->connection    = $connection;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME08000' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' => 
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "CDPICTPROD"   => "P_CDPICTPROD",
          "ORDENA"       => "P_ORDENA"
        )
      ),
      'PME08001' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "CDPICTPROD"   => "P_CDPICTPROD",
          "ORDENA"       => "P_ORDENA"
        )
      ),
      'PME08002' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN"
        )
      ),
      'PME08003' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "ORDENA"       => "P_ORDENA"
        )
      ),
      'PME08004' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "CDPICTPROD"   => "P_CDPICTPROD",
          "ORDENA"       => "P_ORDENA"
        )
      ),
      'PME08005' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN"
          
        )
      ),
      'PME08006' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN"
          
        )
      ),
      'PME08007' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN"
        )
      ),
      'PME08008' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "CDTIPOCARD"   => "P_CDTIPOCARD",
          "UNIDADE"      => "P_CDFILIAL",
          "CDSERVFILI"   => "P_CDSERVFILI",
          "NRCONSPLAN"   => "P_NRCONSPLAN"
          
        )
      ),
      'PME08009' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "CDPICTPRAT"   => "P_CDPICTPRAT",
          "CDPICTPROD"   => "P_CDPICTPROD",
          "ORDENA"       => "P_ORDENA"
        )
      ),
      'PME0800A' => 
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          "DTDE"         => "P_DTINICIAL",
          "DTATE"        => "P_DTFINAL",
          "NMTIPOCUSTO"  => "P_NMCUSTO",
          "NRCONSPLAN"   => "P_NRCONSPLAN",
          "CDFILCENTPME" => "P_CDFILCENTPME",
          "CDTIPOCUSTO"  => "P_NRTIPOCUSTO",
          "CDPICTPROD"   => "P_CDPICTPROD",
          "CDPICTPRAT"   => "P_CDPICTPRAT",
          "ORDENA"       => "P_ORDENA"
        )
      )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->environment->getNrOrgTrab();
      $row['NRCONSPLAN'] = $this->newCode->getCodeByTableName('CONSPLAN'.$row['CDFILCENTPME'], $nrorg);
      
      if(empty($row['TIPOCARD'])) $tipoCard = $this->getCardapio($row);
      else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];

      $this->procedure($row);

      if(empty($row['SERVICO'])) $servico = $this->getServicos($row);
      else $servico = is_array($row['CDSERVFILI']) ? join("_", $row['CDSERVFILI']) : $row['CDSERVFILI'];
      
      if(empty($row['NUTRICIONISTA']) && empty($row['UNIDADE'])) $unidade = $this->getUnidades($row); 
      else {
        if (empty($row['UNIDADE'])) {
          $unidade = $this->getUnidades($row);
        } else{
          $unidade = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        }
      }
      
      $row['UNIDADE'] = $unidade;
      $row['CDFILIAL'] = $unidade;
      $row['SERVICO'] = $servico;
      $row['CDSERVFILI'] = $servico;
      $row['TIPOCUSTO'] = $row['TIPOCUSTO']['CDTIPOCUSTO'];
      $row['CDTIPOCARD'] = $tipoCard;
      
      
      $this->birtStrategy->setReportLocale($this->environment->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
    
    private function procedure($row){
      $nrorg = $this->environment->getNrOrgTrab();
      
      if(empty($row['TIPOCARD'])) $tipoCard =  $this->getCardapio($row);
      else $tipoCard = is_array($row['TIPOCARD']) ? join("_", $row['TIPOCARD']) : $row['TIPOCARD'];
      
      if(empty($row['SERVICO'])) $servico = $this->getServicos($row);
      else $servico = is_array($row['CDSERVFILI']) ? join("_", $row['CDSERVFILI']) : $row['CDSERVFILI'];
      
      if(empty($row['NUTRICIONISTA']) && empty($row['UNIDADE'])) $unidade = $this->getUnidades($row); 
      else {
        if (empty($row['UNIDADE'])) {
          $unidade = $this->getUnidades($row);
        } else{
          $unidade = is_array($row['UNIDADE']) ? join("_", $row['UNIDADE']) : $row['UNIDADE'];
        }
      }
      
      if (($row['CD_REPORT_CODE'] === 'PME08009') || ($row['CD_REPORT_CODE'] === 'PME0800A')) $idseprato = 'P';
      else $idseprato = 'N';
      
      $cdoperador = $this->environment->getCdOperador(); 

      $connection = $this->entityManager->getConnection();
      $procedureCons = new StoredProcedure($connection, 'CONSUMO_PLANEJADO_PME');

      $procedureCons->addParam(new Param('P_CDFILCENTPME', Param::PARAM_INPUT, $row['CDFILCENTPME'], Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDTIPOCARD',   Param::PARAM_INPUT, $tipoCard,            Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $unidade,             Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDSERVFILI',   Param::PARAM_INPUT, $servico,             Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT, $row['DTDE'],         Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT, $row['DTATE'],        Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_IDARQUIVO',    Param::PARAM_INPUT, 'A',                  Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_IDPRODUTOS',   Param::PARAM_INPUT, 'CFP',                Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_IDSEPPRATO',   Param::PARAM_INPUT, $idseprato,           Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT, '0',                  Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT, 'N',                  Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_INPUT, $row['NRCONSPLAN'],   Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, '0',                  Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, 'ZZZZZZZZZ',          Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $cdoperador,          Param::PARAM_TYPE_STR));
      $procedureCons->execute();
    }
    
    private function getUnidades($row){
      $unidades = [];
      $query = "SELECT DISTINCT FI.CDFILIAL, FI.NMFILIAL, FI.NRORG FROM FILIAL FI, FILIOPER FO WHERE (FI.IDFILCENTPME = 'N') AND (FI.CDFILCENTPME = :CDFILCENTPME) AND (FI.CDFILIAL = FO.CDFILIAL) AND (INSTR(:CDOPERADOR, FO.CDOPERADOR) <> 0 OR :CDOPERADOR IS NULL) ORDER BY FI.CDFILIAL";
      $params = array(
        "CDFILCENTPME" => $row["CDFILCENTPME"],
        "CDOPERADOR"   => implode($row['NUTRICIONISTA'])
      );
      $stmt = $this->connection->prepare($query);
		  $stmt->execute($params);
      $result = $stmt->fetchAll();

      foreach($result as $unid){
        array_push($unidades, $unid['CDFILIAL']);
      }
      $resultado = join("_", $unidades);
      return $resultado;
    }
    
    private function getServicos($row){
      $nrorg = $this->environment->getNrOrgTrab();
      $servicos = [];
      
      $query = "SELECT ST.CDTIPOCARD, ST.CDFILCENTPME, ST.CDSERVFILI, S.NMSERVICO, ST.CDSERVFILI || ' - ' || S.NMSERVICO AS DESCRICAO, S.NRORG FROM SERVTIPOCARD ST INNER JOIN SERVICO S ON S.NRORG = ST.NRORG AND S.CDFILIAL = ST.CDFILCENTPME AND S.CDSERVFILI = ST.CDSERVFILI AND S.IDTIPOSERV = 'M' WHERE ST.NRORG = :NRORG AND ST.CDFILCENTPME = :CDFILCENTPME AND (INSTR(NVL(:CDTIPOCARD,ST.CDTIPOCARD), ST.CDTIPOCARD) > 0) ORDER BY ST.CDSERVFILI";
      $params = array(
        "CDFILCENTPME" => $row["CDFILCENTPME"],
        "CDTIPOCARD"   => implode($row["CDTIPOCARD"]),
        "NRORG"        => $nrorg
      );
      $stmt = $this->connection->prepare($query);
		  $stmt->execute($params);
      $result = $stmt->fetchAll();
      
      foreach($result as $serv){
        array_push($servicos, $serv['CDSERVFILI']);
      }
      
      $resultado = join("_", $servicos);
      return $resultado;
    }
    
    private function getCardapio($row){
      $nrorg = $this->environment->getNrOrgTrab();
      $cardapio = [];
      
      $query = "SELECT CDTIPOCARD, NMTIPOCARD, IDTPCARDATIV, NRPASTATCARD, NRORG FROM TIPOCARD WHERE NRORG = :NRORG AND CDFILCENTPME = :CDFILCENTPME AND (NRPASTATCARD = :NRPASTATCARD OR :NRPASTATCARD IS NULL) ORDER BY NRPASTATCARD, CDTIPOCARD";
      $params = array(
        "CDFILCENTPME" => $row["CDFILCENTPME"],
        "NRPASTATCARD" => NULL,
        "NRORG"        => $nrorg
      );
      $stmt = $this->connection->prepare($query);
		  $stmt->execute($params);
      $result = $stmt->fetchAll();
      
      foreach($result as $card){
        array_push($cardapio, $card['CDTIPOCARD']);
      }
      
      $resultado = join("_", $cardapio);
      return $resultado;
    }
}