IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_CALENDORCOPERAC'   AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_CALENDORCOPERAC
GO


CREATE TRIGGER LOG_CALENDORCOPERAC
ON CALENDORCOPERAC
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO   VARCHAR(1);

   DECLARE  @V_OLD_NRANOORCOPERAC  VARCHAR(4);
   DECLARE  @V_OLD_CDFASEORCOPERAC VARCHAR(10);
   DECLARE  @V_OLD_DTINIFASEORCA   DATETIME;
   DECLARE  @V_OLD_DTFINFASEORCA   DATETIME;
   DECLARE  @V_OLD_IDPERMCALCJAN   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCFEV   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCMAR   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCABR   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCMAI   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCJUN   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCJUL   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCAGO   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCSET   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCOUT   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCNOV   VARCHAR(1);
   DECLARE  @V_OLD_IDPERMCALCDEZ   VARCHAR(1);

   DECLARE  @V_NEW_NRANOORCOPERAC  VARCHAR(4);
   DECLARE  @V_NEW_CDFASEORCOPERAC VARCHAR(10);
   DECLARE  @V_NEW_DTINIFASEORCA   DATETIME;
   DECLARE  @V_NEW_DTFINFASEORCA   DATETIME;
   DECLARE  @V_NEW_IDPERMCALCJAN   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCFEV   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCMAR   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCABR   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCMAI   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCJUN   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCJUL   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCAGO   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCSET   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCOUT   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCNOV   VARCHAR(1);
   DECLARE  @V_NEW_IDPERMCALCDEZ   VARCHAR(1);

BEGIN

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      NRANOORCOPERAC,
      CDFASEORCOPERAC,
      DTINIFASEORCA,
      DTFINFASEORCA,
      IDPERMCALCJAN,
      IDPERMCALCFEV,
      IDPERMCALCMAR,
      IDPERMCALCABR,
      IDPERMCALCMAI,
      IDPERMCALCJUN,
      IDPERMCALCJUL,
      IDPERMCALCAGO,
      IDPERMCALCSET,
      IDPERMCALCOUT,
      IDPERMCALCNOV,
      IDPERMCALCDEZ,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE NRANOORCOPERAC  NOT IN (SELECT NRANOORCOPERAC FROM INSERTED)
     AND CDFASEORCOPERAC NOT IN (SELECT CDFASEORCOPERAC FROM INSERTED)

   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.NRANOORCOPERAC,
      DELETED.CDFASEORCOPERAC,
      DELETED.DTINIFASEORCA,
      DELETED.DTFINFASEORCA,
      DELETED.IDPERMCALCJAN,
      DELETED.IDPERMCALCFEV,
      DELETED.IDPERMCALCMAR,
      DELETED.IDPERMCALCABR,
      DELETED.IDPERMCALCMAI,
      DELETED.IDPERMCALCJUN,
      DELETED.IDPERMCALCJUL,
      DELETED.IDPERMCALCAGO,
      DELETED.IDPERMCALCSET,
      DELETED.IDPERMCALCOUT,
      DELETED.IDPERMCALCNOV,
      DELETED.IDPERMCALCDEZ,

      INSERTED.NRANOORCOPERAC,
      INSERTED.CDFASEORCOPERAC,
      INSERTED.DTINIFASEORCA,
      INSERTED.DTFINFASEORCA,
      INSERTED.IDPERMCALCJAN,
      INSERTED.IDPERMCALCFEV,
      INSERTED.IDPERMCALCMAR,
      INSERTED.IDPERMCALCABR,
      INSERTED.IDPERMCALCMAI,
      INSERTED.IDPERMCALCJUN,
      INSERTED.IDPERMCALCJUL,
      INSERTED.IDPERMCALCAGO,
      INSERTED.IDPERMCALCSET,
      INSERTED.IDPERMCALCOUT,
      INSERTED.IDPERMCALCNOV,
      INSERTED.IDPERMCALCDEZ
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.NRANOORCOPERAC  = DELETED.NRANOORCOPERAC
     AND INSERTED.CDFASEORCOPERAC = DELETED.CDFASEORCOPERAC
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NRANOORCOPERAC,
      CDFASEORCOPERAC,
      DTINIFASEORCA,
      DTFINFASEORCA,
      IDPERMCALCJAN,
      IDPERMCALCFEV,
      IDPERMCALCMAR,
      IDPERMCALCABR,
      IDPERMCALCMAI,
      IDPERMCALCJUN,
      IDPERMCALCJUL,
      IDPERMCALCAGO,
      IDPERMCALCSET,
      IDPERMCALCOUT,
      IDPERMCALCNOV,
      IDPERMCALCDEZ
   FROM
      INSERTED
   WHERE NRANOORCOPERAC  NOT IN (SELECT NRANOORCOPERAC FROM DELETED)
     AND CDFASEORCOPERAC NOT IN (SELECT CDFASEORCOPERAC FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_NRANOORCOPERAC,
                                 @V_OLD_CDFASEORCOPERAC,
                                 @V_OLD_DTINIFASEORCA,
                                 @V_OLD_DTFINFASEORCA,
                                 @V_OLD_IDPERMCALCJAN,
                                 @V_OLD_IDPERMCALCFEV,
                                 @V_OLD_IDPERMCALCMAR,
                                 @V_OLD_IDPERMCALCABR,
                                 @V_OLD_IDPERMCALCMAI,
                                 @V_OLD_IDPERMCALCJUN,
                                 @V_OLD_IDPERMCALCJUL,
                                 @V_OLD_IDPERMCALCAGO,
                                 @V_OLD_IDPERMCALCSET,
                                 @V_OLD_IDPERMCALCOUT,
                                 @V_OLD_IDPERMCALCNOV,
                                 @V_OLD_IDPERMCALCDEZ,
                                 @V_NEW_NRANOORCOPERAC,
                                 @V_NEW_CDFASEORCOPERAC,
                                 @V_NEW_DTINIFASEORCA,
                                 @V_NEW_DTFINFASEORCA,
                                 @V_NEW_IDPERMCALCJAN,
                                 @V_NEW_IDPERMCALCFEV,
                                 @V_NEW_IDPERMCALCMAR,
                                 @V_NEW_IDPERMCALCABR,
                                 @V_NEW_IDPERMCALCMAI,
                                 @V_NEW_IDPERMCALCJUN,
                                 @V_NEW_IDPERMCALCJUL,
                                 @V_NEW_IDPERMCALCAGO,
                                 @V_NEW_IDPERMCALCSET,
                                 @V_NEW_IDPERMCALCOUT,
                                 @V_NEW_IDPERMCALCNOV,
                                 @V_NEW_IDPERMCALCDEZ;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_NRANOORCOPERAC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NumAno=' + @V_OLD_NRANOORCOPERAC;
         END;
         IF @V_OLD_CDFASEORCOPERAC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdFase=' + @V_OLD_CDFASEORCOPERAC;
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_DTINIFASEORCA <> @V_NEW_DTINIFASEORCA) BEGIN
               SET @V_DESC = @V_DESC + ' DtInicio=' + CONVERT(VARCHAR,@V_NEW_DTINIFASEORCA);
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_DTFINFASEORCA <> @V_NEW_DTFINFASEORCA) BEGIN
               SET @V_DESC = @V_DESC + ' DtFim=' + CONVERT(VARCHAR,@V_NEW_DTFINFASEORCA);
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCJAN <> @V_NEW_IDPERMCALCJAN) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcJan=' + @V_NEW_IDPERMCALCJAN;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCFEV <> @V_NEW_IDPERMCALCFEV) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcFev=' + @V_NEW_IDPERMCALCFEV;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCMAR <> @V_NEW_IDPERMCALCMAR) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcMar=' + @V_NEW_IDPERMCALCMAR;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCABR <> @V_NEW_IDPERMCALCABR) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcAbr=' + @V_NEW_IDPERMCALCABR;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCMAI <> @V_NEW_IDPERMCALCMAI) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcMai=' + @V_NEW_IDPERMCALCMAI;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCJUN <> @V_NEW_IDPERMCALCJUN) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcJun=' + @V_NEW_IDPERMCALCJUN;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCJUL <> @V_NEW_IDPERMCALCJUL) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcJul=' + @V_NEW_IDPERMCALCJUL;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCAGO <> @V_NEW_IDPERMCALCAGO) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcAgo=' + @V_NEW_IDPERMCALCAGO;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCSET <> @V_NEW_IDPERMCALCSET) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcSet=' + @V_NEW_IDPERMCALCSET;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCOUT <> @V_NEW_IDPERMCALCOUT) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcOut=' + @V_NEW_IDPERMCALCOUT;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCNOV <> @V_NEW_IDPERMCALCNOV) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcNov=' + @V_NEW_IDPERMCALCNOV;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;
            IF (@V_OLD_IDPERMCALCDEZ <> @V_NEW_IDPERMCALCDEZ) BEGIN
               SET @V_DESC = @V_DESC + ' IdPermCalcDez=' + @V_NEW_IDPERMCALCDEZ;
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_NRANOORCOPERAC+';'+@V_OLD_CDFASEORCOPERAC;

            END;

         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_NRANOORCOPERAC+';'+@V_NEW_CDFASEORCOPERAC;

            IF ISNULL(@V_NEW_NRANOORCOPERAC,'!') <> ISNULL(@V_OLD_NRANOORCOPERAC,'!') BEGIN
               SET @V_DESC = @V_DESC + ' NumAno=' + @V_NEW_NRANOORCOPERAC;
            END;

            IF ISNULL(@V_NEW_CDFASEORCOPERAC ,'!') <> ISNULL(@V_OLD_CDFASEORCOPERAC, '!') BEGIN
               SET @V_DESC = @V_DESC + ' CdFase=' + @V_NEW_CDFASEORCOPERAC;
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('CALENDORCOPERAC',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_NRANOORCOPERAC,
                                    @V_OLD_CDFASEORCOPERAC,
                                    @V_OLD_DTINIFASEORCA,
                                    @V_OLD_DTFINFASEORCA,
                                    @V_OLD_IDPERMCALCJAN,
                                    @V_OLD_IDPERMCALCFEV,
                                    @V_OLD_IDPERMCALCMAR,
                                    @V_OLD_IDPERMCALCABR,
                                    @V_OLD_IDPERMCALCMAI,
                                    @V_OLD_IDPERMCALCJUN,
                                    @V_OLD_IDPERMCALCJUL,
                                    @V_OLD_IDPERMCALCAGO,
                                    @V_OLD_IDPERMCALCSET,
                                    @V_OLD_IDPERMCALCOUT,
                                    @V_OLD_IDPERMCALCNOV,
                                    @V_OLD_IDPERMCALCDEZ,
                                    @V_NEW_NRANOORCOPERAC,
                                    @V_NEW_CDFASEORCOPERAC,
                                    @V_NEW_DTINIFASEORCA,
                                    @V_NEW_DTFINFASEORCA,
                                    @V_NEW_IDPERMCALCJAN,
                                    @V_NEW_IDPERMCALCFEV,
                                    @V_NEW_IDPERMCALCMAR,
                                    @V_NEW_IDPERMCALCABR,
                                    @V_NEW_IDPERMCALCMAI,
                                    @V_NEW_IDPERMCALCJUN,
                                    @V_NEW_IDPERMCALCJUL,
                                    @V_NEW_IDPERMCALCAGO,
                                    @V_NEW_IDPERMCALCSET,
                                    @V_NEW_IDPERMCALCOUT,
                                    @V_NEW_IDPERMCALCNOV,
                                    @V_NEW_IDPERMCALCDEZ;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_CALENDORCOPERAC','5.09.000';
GO

